#include <IRremote.hpp>
#include <Arduino.h>

#include "PinDefinitionsAndMore.h" // Define macros for input and output pin etc.

#include <Adafruit_NeoPixel.h>
#include <avr/power.h>

#define PIN 6
#define NUMPIXELS 50    //26
#include <EEPROM.h>

//Controlling coin acceptor with Arduino

#include  <Arduino.h>
//#include <TM1637Display.h>


// Module  connection pins (Digital Pins)
#define CLK 5
#define DIO 4
#include <SPI.h>
#include <Wire.h>
#include <Adafruit_GFX.h>
#include <Adafruit_SSD1306.h>

#define SCREEN_WIDTH 128 // OLED display width, in pixels
#define SCREEN_HEIGHT 32 // OLED display height, in pixels

// Declaration for an SSD1306 display connected to I2C (SDA, SCL pins)
// The pins for I2C are defined by the Wire-library. 
// On an arduino UNO:       A4(SDA), A5(SCL)
// On an arduino MEGA 2560: 20(SDA), 21(SCL)
// On an arduino LEONARDO:   2(SDA),  3(SCL), ...
#define OLED_RESET     -1 // Reset pin # (or -1 if sharing Arduino reset pin)
#define SCREEN_ADDRESS 0x3C ///< See datasheet for Address; 0x3D for 128x64, 0x3C for 128x32
Adafruit_SSD1306 display(SCREEN_WIDTH, SCREEN_HEIGHT, &Wire, OLED_RESET);



#if FLASHEND >= 0x3FFF  // For 16k flash or more, like ATtiny1604. Code does not fit in program memory of ATtiny85 etc.
// !!! Enabling B&O disables detection of Sony, because the repeat gap for SONY is smaller than the B&O frame gap :-( !!!
//#define DECODE_BEO // Bang & Olufsen protocol always must be enabled explicitly. It has an IR transmit frequency of 455 kHz! It prevents decoding of SONY!
#endif
#if defined(DECODE_BEO)
#define RECORD_GAP_MICROS 16000 // always get the complete frame in the receive buffer, but this prevents decoding of SONY!
#endif


#if defined(APPLICATION_PIN)
#define DEBUG_BUTTON_PIN    APPLICATION_PIN // if low, print timing for each received data set
#else
#define DEBUG_BUTTON_PIN   6
#endif

Adafruit_NeoPixel pixels = Adafruit_NeoPixel (NUMPIXELS, PIN, NEO_GRB + NEO_KHZ800);
void generateTone();
void handleOverflow();
bool detectLongPress(uint16_t aLongPressDurationMillis);
// variable use to measuer the intervals inbetween impulses
int  j=0;
// Number of impulses detected
int impulsCount=0;
const int button = 8;
int buttonState=0;
// Sum of all the  coins inseted
float total_amount=0;
float total_amount_game=0;
//int zero = 0;

void setup() {
#if FLASHEND >= 0x3FFF  // For 16k flash or more, like ATtiny1604. Code does not fit in program memory of ATtiny85 etc.
    pinMode(DEBUG_BUTTON_PIN, INPUT_PULLUP);
#endif

    //Serial.begin(115200); For the Ir Reciver
    //Serial.begin(9600); If it's necessary to output something to the screen
    pixels.begin();
#if defined(__AVR_ATmega32U4__) || defined(SERIAL_PORT_USBVIRTUAL) || defined(SERIAL_USB) /*stm32duino*/|| defined(USBCON) /*STM32_stm32*/|| defined(SERIALUSB_PID) || defined(ARDUINO_attiny3217)
    delay(4000); // To be able to connect Serial monitor after reset or power up and before first print out. Do not wait for an attached Serial Monitor!
#endif

    IrReceiver.begin(IR_RECEIVE_PIN, ENABLE_LED_FEEDBACK);

  if(!display.begin(SSD1306_SWITCHCAPVCC, SCREEN_ADDRESS)) {
    Serial.println(F("SSD1306 allocation failed"));
    for(;;); // Don't proceed, loop forever
  }

  pinMode(3, INPUT_PULLUP);
  pinMode(button, INPUT);  //definir pin como salida
  pinMode(7,OUTPUT);

 // Interrupt connected  to PIN D3 executing IncomingImpuls function when signal goes from HIGH to LOW
  attachInterrupt(1,incomingImpuls, FALLING);
  EEPROM.get(0, total_amount); //The value of total_amount is obtained from the Arduino's memory that previously was set

}
void incomingImpuls()
{
  impulsCount=impulsCount+1;
  j=0;
}
void loop() {

  uint32_t black = pixels.Color(0,0,0);
  uint32_t red = pixels.Color(255,0,0);
  uint32_t green = pixels.Color(0,255,0);
  uint32_t blue = pixels.Color(0,0,255);
  uint32_t white = pixels.Color(255,255,255);
  uint32_t orange = pixels.Color(255,110,0);
  uint32_t yellow = pixels.Color(255,255,0);
  uint32_t red2 = pixels.Color(255,40,255);
  uint32_t orange2 = pixels.Color(255,160,0);
  uint32_t dark_green = pixels.Color(0,113,11);
  uint32_t turquoise = pixels.Color(0,220,198);
  uint32_t green2 = pixels.Color(13,127,116);
  uint32_t blue2 = pixels.Color(1,75,67);
  uint32_t dark_blue = pixels.Color(0,65,206);
  uint32_t dark_purple = pixels.Color(97,0,105);
  uint32_t purple = pixels.Color(188,0,205);
  uint32_t pink = pixels.Color(255,0,212);  


    if (IrReceiver.decode()) {
        //Serial.println();
#if FLASHEND < 0x3FFF  //
        // For less than 16k flash, only print a minimal summary of received data
       // IrReceiver.printIRResultMinimal(&Serial);
#else

        if (IrReceiver.decodedIRData.flags & IRDATA_FLAGS_WAS_OVERFLOW) {
            handleOverflow();
        } else {
            /*
             * No overflow here.
             * Stop receiver, generate a single beep, print short info and send usage and start receiver again
             *****************************************************************************************************/

            if ((IrReceiver.decodedIRData.protocol != SONY) && (IrReceiver.decodedIRData.protocol != PULSE_WIDTH)
                    && (IrReceiver.decodedIRData.protocol != PULSE_DISTANCE) && (IrReceiver.decodedIRData.protocol != UNKNOWN)
                    && digitalRead(DEBUG_BUTTON_PIN) != LOW) {
                /*
                 * For SONY the tone prevents the detection of a repeat after the 15 ms SONY gap.
                 * In debug mode and for unknown protocols, we need the time for extended output.
                 * Skipping tone will get exact gap time between transmissions and not running into repeat frames while wait for tone to end.
                 * This in turn enables the next CheckForRecordGapsMicros() call a chance to eventually propose a change of the current RECORD_GAP_MICROS value.
                 */
                generateTone();
            }

            /*
             * Print info
             */
            if (IrReceiver.decodedIRData.protocol == UNKNOWN || digitalRead(DEBUG_BUTTON_PIN) == LOW) {
                // We have debug enabled or an unknown protocol, print extended info
                if (IrReceiver.decodedIRData.protocol == UNKNOWN) {
                    Serial.println(F("Received noise or an unknown (or not yet enabled) protocol"));
                }
                //IrReceiver.printIRResultRawFormatted(&Serial, true);
            } else {
                /*
                 * This is the info output for a successful receive in normal mode
                 */
               //IrReceiver.printIRResultShort(&Serial);
                //IrReceiver.printIRSendUsage(&Serial);
            }
        }
#endif 
        IrReceiver.resume();

        /*
         * Finally check the received data and perform actions according to the received address and commands
         */

        if (IrReceiver.decodedIRData.address == 0) {
            //IrReceiver.decodedIRData.command == 0x9 (The address of the button that you pressed in the dispositve with Ir emisor)
            if (IrReceiver.decodedIRData.command == 0x9) {
                 
                  for (int i=0;i<NUMPIXELS;i++)
                    {
                      
                      if (i == 0)
                      {
                      pixels.setPixelColor (i,green);
                      pixels.show();
                      }
                      else if (i%2 == 0)
                      {
                      pixels.setPixelColor (i,green);
                      pixels.show();
                      }                     
                      else
                      {
                      pixels.setPixelColor (i,white);
                      pixels.show();       
                      }    
                      };                
            }
            else if (IrReceiver.decodedIRData.command == 0x1D) {
                              
                  for (int i=0;i<NUMPIXELS;i++)
                    {
                      
                      if (i == 0)
                      {
                      pixels.setPixelColor (i,red);
                      pixels.show();
                      }
                      else if (i%2 == 0)
                      {
                      pixels.setPixelColor (i,red);
                      pixels.show();
                      }                     
                      else
                      {
                      pixels.setPixelColor (i,white);
                      pixels.show();       
                      }    
                      };   
            }
            else if (IrReceiver.decodedIRData.command == 0x4D) {
                                       
                  for (int i=0;i<NUMPIXELS;i++)
                    {
                      
                      if (i == 0)
                      {
                      pixels.setPixelColor (i,red);
                      pixels.show();
                      }
                      else if (i%2 == 0)
                      {
                      pixels.setPixelColor (i,red);
                      pixels.show();
                      }                     
                      else
                      {
                      pixels.setPixelColor (i,yellow);
                      pixels.show();       
                      }    
                      };   
            }             
            else if (IrReceiver.decodedIRData.command == 0x1F) {
                     total_amount_game += 1;                  
                    for (int i=0;i<NUMPIXELS;i++)
                    {
                      pixels.setPixelColor (i,black);
                      pixels.show();
                    };
            }
            else if (IrReceiver.decodedIRData.command == 0xD) {
                    display.clearDisplay(); 
                    display.display();                                  
                    total_amount = 0;
                    EEPROM.put(0, total_amount);
            } 
            
            else if (IrReceiver.decodedIRData.command == 0x1A) {
                                        
                  for (int i=0;i<NUMPIXELS;i++)
                    {
                      
                      if (i == 0)
                      {
                      pixels.setPixelColor (i,white);
                      pixels.show();
                      }
                      else if (i%2 == 0)
                      {
                      pixels.setPixelColor (i,white);
                      pixels.show();
                      }                     
                      else
                      {
                      pixels.setPixelColor (i,black);
                      pixels.show();       
                      }    
                      };
            }                               
            else if (IrReceiver.decodedIRData.command == 0x11) {
                                        
                  
                  for (int i=0;i<NUMPIXELS;i++)
                    {
                      pixels.setPixelColor (i,blue);
                      pixels.show();
                    };
            }
            else if (IrReceiver.decodedIRData.command == 0x1B) {
                                                         
                    for (int i=0;i<NUMPIXELS;i++)
                    {
                      pixels.setPixelColor (i,green);
                      pixels.show();
                    };
            }
            else if (IrReceiver.decodedIRData.command == 0x19) {
                                                        
                    for (int i=0;i<NUMPIXELS;i++)
                    {
                      pixels.setPixelColor (i,red);
                      pixels.show();
                    };
            }
            else if (IrReceiver.decodedIRData.command == 0x15) {
                                       
                    for (int i=0;i<NUMPIXELS;i++)
                    {
                      pixels.setPixelColor (i,white);
                      pixels.show();
                    };
            }
            else if (IrReceiver.decodedIRData.command == 0x17) {
                                        
                    for (int i=0;i<NUMPIXELS;i++)
                    {
                      pixels.setPixelColor (i,red2);
                      pixels.show();
                    };
            }            
            else if (IrReceiver.decodedIRData.command == 0x40) {
                                     
                    for (int i=0;i<NUMPIXELS;i++)
                    {
                      pixels.setPixelColor (i,orange);
                      pixels.show();
                    };
            }
            else if (IrReceiver.decodedIRData.command == 0xA) {
                                      
                    for (int i=0;i<NUMPIXELS;i++)
                    {
                      pixels.setPixelColor (i,orange2);
                      pixels.show();
                    };
            }
            else if (IrReceiver.decodedIRData.command == 0x1C) {
                                        
                    for (int i=0;i<NUMPIXELS;i++)
                    {
                      pixels.setPixelColor (i,yellow);
                      pixels.show();
                    };
            }
            else if (IrReceiver.decodedIRData.command == 0x12) {
                    
                    for (int i=0;i<NUMPIXELS;i++)
                    {
                      pixels.setPixelColor (i,dark_green);
                      pixels.show();
                    };
            }
            else if (IrReceiver.decodedIRData.command == 0x4C) {
                         
                    for (int i=0;i<NUMPIXELS;i++)
                    {
                      pixels.setPixelColor (i,turquoise);
                      pixels.show();
                    };
            }
            else if (IrReceiver.decodedIRData.command == 0x1E) {
                    
                    for (int i=0;i<NUMPIXELS;i++)
                    {
                      pixels.setPixelColor (i,green2);
                      pixels.show();
                    };
            }
            else if (IrReceiver.decodedIRData.command == 0x14) {
                   
                    for (int i=0;i<NUMPIXELS;i++)
                    {
                      pixels.setPixelColor (i,blue2);
                      pixels.show();
                    };
            }
            else if (IrReceiver.decodedIRData.command == 0x16) {
                    
                    for (int i=0;i<NUMPIXELS;i++)
                    {
                      pixels.setPixelColor (i,dark_blue);
                      pixels.show();
                    };
            }
            else if (IrReceiver.decodedIRData.command == 0x4) {
                 
                    for (int i=0;i<NUMPIXELS;i++)
                    {
                      pixels.setPixelColor (i,dark_purple);
                      pixels.show();
                    };
            }
            else if (IrReceiver.decodedIRData.command == 0xE) {
                    
                    for (int i=0;i<NUMPIXELS;i++)
                    {
                      pixels.setPixelColor (i,purple);
                      pixels.show();
                    };
            }
            else if (IrReceiver.decodedIRData.command == 0xF) {

                    for (int i=0;i<NUMPIXELS;i++)
                    {
                      pixels.setPixelColor (i,pink);
                      pixels.show();
                    };
            }
            else if (IrReceiver.decodedIRData.command == 0xF) {
                   
                    for (int i=0;i<NUMPIXELS;i++)
                    {
                      pixels.setPixelColor (i,pink);
                      pixels.show();
                    };
            }           
        }

        // Check if repeats of the IR command was sent for more than 1000 ms
        if (detectLongPress(1000)) {
            Serial.print(F("Command 0x"));
            Serial.print(IrReceiver.decodedIRData.command, HEX);
            Serial.println(F(" was repeated for more than 2 seconds"));
        }
    } // if (IrReceiver.decode())


  buttonState = digitalRead(button);
          j++;

 /* Serial.print("i=");
  Serial.print(j);
  Serial.print(" Impulses:");
  Serial.print(impulsCount);
  Serial.print(" Total:");
  Serial.print(total_amount);
  Serial.print(" Juego:");
  Serial.println(total_amount_game);*/
  if (j>=30 and impulsCount==1)
  {
    impulsCount=0; 
    total_amount_game += 0.1; //10 cents
    total_amount+=0.1;
    EEPROM.put(0, total_amount);                        
  } 
  if (j>=30 and impulsCount==2)
  {
    total_amount+=0.2; //20 cents
    total_amount_game+=0.2;
    impulsCount=0;
    EEPROM.put(0, total_amount);
  }
  if (j>=30 and impulsCount==3)
  {
    total_amount+=0.5; // 50 cents
    total_amount_game+=0.5;
    impulsCount=0;
    EEPROM.put(0, total_amount);                      
  }
  if (j>=30 and  impulsCount==4)
  {
    total_amount+=1; // 1 euro
    total_amount_game+=1;
    impulsCount=0;
    EEPROM.put(0, total_amount);
  }
  if (j>=30 and impulsCount==5)
  {
    total_amount+=0.5; //25 pesetas 
    total_amount_game += 0.5;
    impulsCount=0;
    EEPROM.put(0, total_amount);
  }
  if (j>=30 and impulsCount==6)
  {
    total_amount+=2; //2 euros 
    total_amount_game += 2;
    impulsCount=0;
    EEPROM.put(0, total_amount);
  }
  if (total_amount_game >= 0.5)
  {
    total_amount_game -= 0.5;
    digitalWrite(7 , HIGH);   // Coin signal to the raspberry
    delay(100);               // To simulate the pulse of a button
    digitalWrite(7, LOW); 
    for (int i=0;i<NUMPIXELS;i++)
    {
    pixels.setPixelColor (i,black);
    pixels.show();      
    }; 
    delay (100);
    for (int i=0;i<NUMPIXELS;i++)
    {
    pixels.setPixelColor (i,green);
    pixels.show();     
    };
    delay (100);

    for (int i=0;i<NUMPIXELS;i++)
    {
    pixels.setPixelColor (i,black);
    pixels.show();      
    }; 
    delay (100);
    for (int i=0;i<NUMPIXELS;i++)
    {
    pixels.setPixelColor (i,green);
    pixels.show();       
    };
    delay (100); 

    for (int i=0;i<NUMPIXELS;i++)
    {
    pixels.setPixelColor (i,black);
    pixels.show();       
    }; 
    delay (100);
    for (int i=0;i<NUMPIXELS;i++)
    {
    pixels.setPixelColor (i,green);
    pixels.show();      
    }; 
  }
              
  if (buttonState == LOW) 
  {
    display.clearDisplay();
    // Text size
    display.setTextSize(3);
    // Text color
    display.setTextColor(SSD1306_WHITE);
    // Text position
    display.setCursor(30, 8);
    // Show the total amount of money that you spent on the machine
    display.println(total_amount); 
    // Show in the display
    display.display();
  } 
  else
  {
    display.clearDisplay(); //If the button is not pressed, nothing is shown
    display.display(); 
  }  
}

// 
void generateTone() {
#if !defined(ESP8266) && !defined(NRF5) // tone on esp8266 works only once, then it disables IrReceiver.restartTimer() / timerConfigForReceive().
#  if defined(ESP32) // ESP32 uses another timer for tone()
            tone(TONE_PIN, 2200, 5);
#  else
    IrReceiver.stopTimer(); // ESP32 uses another timer for tone(), maybe other platforms (not tested yet) too.
    tone(TONE_PIN, 2200, 8);
    delay(8);
    IrReceiver.restartTimer(8000); // Restart IR timer. 8000 to compensate for 8 ms stop of receiver. This enables a correct gap measurement.
#  endif
#endif
}

void handleOverflow() {
    Serial.println(F("Overflow detected"));
    Serial.println(F("Try to increase the \"RAW_BUFFER_LENGTH\" value of " STR(RAW_BUFFER_LENGTH) " in " __FILE__));
    // see also https://github.com/Arduino-IRremote/Arduino-IRremote#compile-options--macros-for-this-library

#if !defined(ESP8266) && !defined(NRF5) // tone on esp8266 works once, then it disables IrReceiver.restartTimer() / timerConfigForReceive().
    /*
     * Stop timer, generate a double beep and start timer again
     */
#  if defined(ESP32) // ESP32 uses another timer for tone()
    tone(TONE_PIN, 1100, 10);
    delay(50);
    tone(TONE_PIN, 1100, 10);
#  else
    IrReceiver.stopTimer();
    tone(TONE_PIN, 1100, 10);
    delay(50);
    tone(TONE_PIN, 1100, 10);
    delay(50);
    IrReceiver.restartTimer(100000); // to compensate for 100 ms stop of receiver. This enables a correct gap measurement.
#  endif
#endif
}

unsigned long sMillisOfFirstReceive;
bool sLongPressJustDetected;
/**
 * True once we received the consecutive repeats for more than aLongPressDurationMillis milliseconds.
 * The first frame, which is no repeat, is NOT counted for the duration!
 * @return true once after the repeated IR command was received for longer than aLongPressDurationMillis milliseconds, false otherwise.
 */
bool detectLongPress(uint16_t aLongPressDurationMillis) {
    if (!sLongPressJustDetected && (IrReceiver.decodedIRData.flags & IRDATA_FLAGS_IS_REPEAT)) {
        /*
         * Here the repeat flag is set (which implies, that command is the same as the previous one)
         */
        if (millis() - aLongPressDurationMillis > sMillisOfFirstReceive) {
            sLongPressJustDetected = true; // Long press here
        }
    } else {
        // No repeat here
        sMillisOfFirstReceive = millis();
        sLongPressJustDetected = false;
    }
    return sLongPressJustDetected; // No long press here
}
